/*====================================================================*/
/* Copyright (c)                                                      */
/* [̧ٖ] usbio.c                                                   */
/* [T  v] USB I/O Tv                                          */
/* [Q  ]                                                           */
/* [  ] 2009/08/07       ō쐬ҁFtanaka                       */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*====================================================================*/
/*--------------------------------------------------------------------*/
/*        ݸٰ                                                     */
/*--------------------------------------------------------------------*/
#include <string.h>
#include <windows.h>
#include <commctrl.h>
#include <setupapi.h>         /* ޲ײތpɒǉ */
#include <dbt.h>
#include "resource.h"
#include "commands.h"

/*--------------------------------------------------------------------*/
/*        ŗL`                                                    */
/*--------------------------------------------------------------------*/
/* ---> ޲ײތpɒǉ */
#pragma once
#pragma comment(lib,"setupapi.lib")
#pragma comment(lib,"comctl32.lib")
/* <--- ޲ײތpɒǉ */

/*--------------------------------------------------------------------*/
/*        萔`                                                    */
/*--------------------------------------------------------------------*/
#define MSGDISPATCH(msg,fn)   case msg: return(fn(hDlg,wParam,lParam))
#define GETHINST(x)           ((HINSTANCE)GetWindowLong(x,GWL_HINSTANCE))

/*--------------------------------------------------------------------*/
/*        \̒`                                                  */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*        O[o                                                  */
/*--------------------------------------------------------------------*/
/*--- 78K0 ޯėp۸(HEX̧ق߰) ---*/
const unsigned char  *fw[] = {
    ":010080007F00",
    ":01008100007E",
    ":01008400007B",
    ":03F000009B69F118",
    ":10F00E00B7D6C5C6D4855D10A30032B6AFC7AFC99B",
    ":10F01E00AFB4B2B3B5B3CBB0AFB7B1891CDA0A0097",
    ":10F02E00991CD6100100B1C6CA0A009A1FF0B04250",
    ":10F03E0052BD08C69A0EF062314FE8B0B0B0B0B013",
    ":10F04E00B0B6AF60F68431078002FAFAAF138400CF",
    ":10F05E0031078002FAFAF00FA30032AFB7B1B1B1A7",
    ":10F06E00891CD6AE044D00BD0510A000FA0310E0B9",
    ":10F07E000060BE033B011001009A51F0AE03A000E8",
    ":10F08E00309A51F0A10F5E0FBE029A5BF062BE0184",
    ":10F09E003A01AE02A00030690130D2B0B0B0B6AFC6",
    ":10F0AE00B71000009A6AF0C2D6A000309A27F0C6B8",
    ":10F0BE00A1009A27F01001009A6AF0C2D6A0003083",
    ":10F0CE009A27F0C6A1009A27F0B6AFB7B1B1891C46",
    ":10F0DE00D6AE02262626265DF072AE0830AE09D4D4",
    ":10F0EE008526265DFC6162AE0830AE0980D4852689",
    ":10F0FE00265D03616ABE01AE0830AE0980D4852656",
    ":10F10E00265DFC974B01AE01A000309A51F087A00E",
    ":10F11E0000309A51F04A01AE010D10BE014B01AE06",
    ":10F12E0001A000309A51F087A000309A51F04A01A8",
    ":10F13E00B0B0B6AF0A011B012B013A014A01710BA7",
    ":10F14E0021711A21712B21713B21714B21138040AA",
    ":10F15E0013811E717A80AF138000AFB7B1B1891CD5",
    ":10F16E00D6110100110300110600110C001321FF2E",
    ":10F17E0013230F132603132C01A100BE01AE014170",
    ":10F18E00BD039B6AF39A1DF0C2BE0330BE02EAFFB6",
    ":10F19E0000ADEAA000AE036168AD06A1FFBE01FAA4",
    ":10F1AE00DCAE014D0BAD029DD4610130A10027CA2A",
    ":10F1BE00C7F1D4853084853198DFF1BFF2CAF2D51C",
    ":10F1CE00F2E0F2EAF2F4F2FEF20BF315F31FF3297A",
    ":10F1DE00F3AE0230AE03EA3200AD058D039BBCF2F6",
    ":10F1EE00DA1B009D039BBCF230273027CA04F2D4F1",
    ":10F1FE0085308485319834F2BCF2BCF2BCF2BCF29C",
    ":10F20E00BCF23BF241F247F24DF253F259F263F285",
    ":10F21E006DF277F281F28BF291F297F29DF2A3F2F8",
    ":10F22E00A9F2AEF2B3F2A1FFBE019BBCF2A101BEE8",
    ":10F23E0001FA7BA102BE01FA75A103BE01FA6FA10C",
    ":10F24E0004BE01FA69A105BE01FA63F000A0003008",
    ":10F25E009A27F0FA59F001A000309A27F0FA4FF0F1",
    ":10F26E0003A000309A27F0FA45F006A000309A2746",
    ":10F27E00F0FA3BF00CA000309A27F0FA31A106BE4E",
    ":10F28E0001FA2BA107BE01FA25A108BE01FA1FA1A2",
    ":10F29E0009BE01FA19A10ABE01FA139A42F1FA0E39",
    ":10F2AE009AAEF0FA09A1009E0CF0A10BBE019B676D",
    ":10F2BE00F3AE02F620A100BE019B67F3AE02F6216B",
    ":10F2CE00A100BE019B67F3AE02F623A100BE019B17",
    ":10F2DE0067F3AE02F626A100BE01FA7DAE02F62C51",
    ":10F2EE00A100BE01FA73AE02F200A100BE01FA69DE",
    ":10F2FE009A65F1AE02F201A100BE01FA5CAE02F215",
    ":10F30E0003A100BE01FA52AE02F206A100BE01FA3E",
    ":10F31E0048AE02F20CA100BE01FA3E140CF085417B",
    ":10F32E00955172B7AE021604F0BAB6854D088D2906",
    ":10F33E00A100958E0CF04D089D1BA00030CA04F064",
    ":10F34E00B18E0CF041A000309AD9F0B0140CF085BB",
    ":10F35E000D0295FADEA100BE019B8BF1B0B0B6AFE7",
    ":00000001FF",
    NULL
};
/*--- ѥƭɒǉ鍀 ---*/
const struct {
    LPSTR  lpszMsg;
    int    nID;
} menu[] = {
    {"߰",IDM_PORT},{"",IDM_SCRIPT},{"ްޮ",IDM_VERSION}
};
/*--- ѥƭǉ ---*/
MENUITEMINFO  mii = {
    sizeof(mii),
    MIIM_ID | MIIM_TYPE | MIIM_STATE,
    MFT_STRING,
    MFS_ENABLED,
    IDM_PORT,
    0,
    0,
    NULL,
    0,
    NULL,
    4 //
};
/*--- zCOM߰ĥ ---*/
HANDLE  hCom = INVALID_HANDLE_VALUE;
/*--- ۸ѥ޳۰ޏ ---*/
BOOL   bLoad = FALSE;   /* TRUE=_E[hς݁AFALSE=_E[h */
/*--- ݂߰Ē`ۑ ---*/
struct {
    BYTE   dirp0;       /* Port0 1=output,0=input */
    BYTE   dirp12;      /* Port12 1=output,0=input */
    BYTE   dirp3;       /* Port3 1=output,0=input */
    BYTE   dirp6;       /* Port6 1=output,0=input */
    BYTE   dirp1;       /* Port1 1=output,0=input */
    BYTE   enad;        /* 1=AD,0=port */
} port = {0,0,0,0,0,0};

/*--------------------------------------------------------------------*/
/*        R[h                                                      */
/*--------------------------------------------------------------------*/
/*
* GUID ׽̂B
* ݁FTRUE=AFALSE=ُ
*/
static BOOL WINAPI CheckClassValues(
GUID *lpcg) {       // GUID ߲
    CHAR   szGUID[512];
    CHAR   szClassName[512];
    LPGUID pGUID = lpcg;
    wsprintf(szGUID,
             "{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
             pGUID->Data1,
             pGUID->Data2,
             pGUID->Data3,
             pGUID->Data4[0],
             pGUID->Data4[1],
             pGUID->Data4[2],
             pGUID->Data4[3],
             pGUID->Data4[4],
             pGUID->Data4[5],
             pGUID->Data4[6],
             pGUID->Data4[7]);
    if((SetupDiClassNameFromGuid(lpcg,
                                 szClassName,
                                 sizeof(szClassName),
                                 NULL))&&
       (!lstrcmp(szClassName,"Ports"))) {
        return(TRUE);
    }
    return(FALSE);
}
/*
* ذ̂COM߰Ĕԍ擾B
* ݁F-1!= ̂ƂA-1==̂Ƃُ
*/
static int WINAPI GetComPortNum(VOID) {
    /*--- pذ ---*/
    static CHAR gszDeviceDesc[] = "NEC Electronics USB to RS232C Converter Virtual COM Port";
    /*--- ߰Ă̸׽ID ---*/
    static GUID CYUSBDRV_GUID = {
        0x4D36E978, 0xE325, 0x11CE, 0xBF, 0xC1, 0x08, 0x00, 0x2B, 0xE1, 0x03, 0x18
    };
    static SP_CLASSIMAGELIST_DATA ClassImageListData;
    CHAR             szClassDesc[512];
    CHAR             szDeviceDesc[512];
    GUID             ClassGuid;
    HDEVINFO         hDevInfo;
    SP_DEVINFO_DATA  DevInfoData;
    int              i;
    BOOL             bSubTree;
    UINT             iImage;
    CHAR            *lps;
    int              rtc = -1;

    hDevInfo = SetupDiGetClassDevs(&CYUSBDRV_GUID,
                                   NULL,
                                   NULL,
                                   DIGCF_PRESENT);
    if(hDevInfo == INVALID_HANDLE_VALUE) {
        return(-1);
    }
    SetupDiGetClassDescription(&CYUSBDRV_GUID,szClassDesc,sizeof(szClassDesc),NULL);
    SetupDiGetClassImageIndex(&ClassImageListData,&CYUSBDRV_GUID,&iImage);
    bSubTree = TRUE;
    DevInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
    for (i = 0;SetupDiEnumDeviceInfo(hDevInfo,i,&DevInfoData);i++) {
        ClassGuid = DevInfoData.ClassGuid;
        if(bSubTree) {
            if(CheckClassValues(&ClassGuid) != TRUE) {
                break;
            }
            bSubTree = FALSE;
        }
        if(!SetupDiGetDeviceRegistryProperty(
                hDevInfo,
                &DevInfoData,
                SPDRP_FRIENDLYNAME,
                NULL,
                szDeviceDesc,
                sizeof(szDeviceDesc),
                NULL)) {
            if(!SetupDiGetDeviceRegistryProperty(
                    hDevInfo,
                    &DevInfoData,
                    SPDRP_DEVICEDESC,
                    NULL,
                    szDeviceDesc,
                    sizeof(szDeviceDesc),
                    NULL)) {
                strcpy(szDeviceDesc,"No Device Names");
            }
        }
        if((!strncmp(szDeviceDesc,gszDeviceDesc,strlen(gszDeviceDesc)))&&
           ((lps = strstr(szDeviceDesc,"(COM")) != 0)) {
            rtc = strtoul(&lps[4],0,0);
            break;
        }
    }
    SetupDiDestroyDeviceInfoList(hDevInfo);
    return(rtc);
}
/*
* gZahnr̎seXgB
* ݁FTRUE=sAFALSE=s
*/
BOOL WINAPI checkTrg78k(VOID) {
    DWORD  cbWrite;
    DWORD  cbRead;
    CHAR   szBuf[128];

    WriteFile(hCom,"\r",1,&cbWrite,NULL);
    Sleep(2);
    ReadFile(hCom,szBuf,sizeof(szBuf),&cbRead,NULL);
    if((strstr(szBuf,"ToragiBIOS Version 1.20A"))||
       ((szBuf[0] == '\r')&&(szBuf[1] == '\n')&&(szBuf[2] == '>'))) {
        return(TRUE);
    }
    return(FALSE);
}
/*
* 78K0 ̂q`lœ삷vO_E[hB
*/
BOOL WINAPI download(VOID) {
    DWORD  cbWrite;
    DWORD  cbRead;
    CHAR   szBuf[256];
    int    nloc;

    WriteFile(hCom,"load\r",5,&cbWrite,NULL);
    Sleep(2);
    ReadFile(hCom,szBuf,sizeof(szBuf),&cbRead,NULL);
    for(nloc = 0;fw[nloc] != NULL;nloc++) {
        WriteFile(hCom,fw[nloc],strlen(fw[nloc]),&cbWrite,NULL);
        WriteFile(hCom,"\r",1,&cbWrite,NULL);
        Sleep(2);
    }
    ReadFile(hCom,szBuf,sizeof(szBuf),&cbRead,NULL);
    WriteFile(hCom,"jmp f000\r",9,&cbWrite,NULL);
    ReadFile(hCom,szBuf,sizeof(szBuf),&cbRead,NULL);
    return(TRUE);
}
/*
* COM |[gB
* ݁FTRUE=AFALSE=ُ
*/
BOOL WINAPI initComm(HWND hDlg) {
    DCB           dcb;
    COMMTIMEOUTS  to;
    int           num;
    CHAR          szBuf[32];

    num = GetComPortNum();
    if(num < 0) {
        hCom = INVALID_HANDLE_VALUE;
        MessageBox(hDlg,"78K USBϲ݂܂BڑĂB","USBIO-Error",MB_OK);
        bLoad = FALSE;
        return(FALSE);
    }
    wsprintf(szBuf,"\\\\.\\COM%d",num);
    hCom = CreateFile(szBuf,
                      GENERIC_READ | GENERIC_WRITE,
                      0,
                      NULL,
                      OPEN_EXISTING,
                      0,
                      NULL);
    if(hCom == INVALID_HANDLE_VALUE) {
        MessageBox(hDlg,"78K USBϲ݂܂BĐڑĂ݂ĂB","USBIO-Error",MB_OK);
        bLoad = FALSE;
        return(FALSE);
    }
    GetCommState(hCom,&dcb);
    dcb.BaudRate = 9600;
    dcb.ByteSize = 8;
    dcb.Parity   = 0;
    dcb.StopBits = 0;
    dcb.fParity  = FALSE;
    SetupComm(hCom,4096,4096);
    SetCommState(hCom,&dcb);
    GetCommTimeouts(hCom,&to);
    to.ReadIntervalTimeout         = 500;
    to.ReadTotalTimeoutConstant    = 50;
    to.ReadTotalTimeoutMultiplier  = 0;
    to.WriteTotalTimeoutMultiplier = 0;
    to.WriteTotalTimeoutConstant   = 500;
    SetCommTimeouts(hCom,&to);
    PurgeComm(hCom,PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
    Sleep(20);
    if(checkTrg78k()) {
        download();
        bLoad = TRUE;
    } else {
        CloseHandle(hCom);
        hCom = INVALID_HANDLE_VALUE;
        MessageBox(hDlg,"x 78K USBϲ݂OAؾĂĂ݂ĂB","USBIO-Error",MB_OK);
        bLoad = FALSE;
        return(FALSE);
    }
    return(TRUE);
}
/*
* ݒ肳ꂽf[^COM|[gɏށB
* ݁FۂɑMꐔ
*/
DWORD WINAPI SendCode(BYTE *lpc,int bcc) {
    DWORD  cbWrite = 0;

    if(bLoad) {
        WriteFile(hCom,lpc,bcc,&cbWrite,NULL);
    }
    return(cbWrite);
}
/*
* COM |[gwꐔMB
* ݁FۂɎMꐔ
*/
long WINAPI RecvCode(BYTE *lpc,int bcc) {
    DWORD  cbRead = 0;

    if(bLoad) {
        ReadFile(hCom,lpc,bcc,&cbRead,NULL);
    }
    return(cbRead);
}
/*
* ɂă_CAOE{bNX
*/
BOOL WINAPI AboutDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam) {
    PAINTSTRUCT  ps;
    HDC          hDC;

    switch(uMsg) {
        case WM_INITDIALOG:
            return(TRUE);
        // used to paint the bitmap
        case WM_PAINT:
            // load bitmap and display it
            hDC = BeginPaint(hDlg,&ps);
            EndPaint(hDlg,&ps);
            break;
        case WM_COMMAND:
            switch(LOWORD(wParam)) {
                case IDOK:
                    EndDialog(hDlg,TRUE);
                    return(TRUE);
                case IDCANCEL:
                    EndDialog(hDlg,FALSE);
                    return(TRUE);
            }
            break;
        case WM_CLOSE:
            SendMessage(hDlg,WM_COMMAND,IDCANCEL,0);
            break;
    }
    return(FALSE);
}
/*
* ݒ肳ꂽID̃`FbNEWIE{^ݒ肷B
*/
void WINAPI SetupChekRadioButton(HWND hDlg,int nID,BYTE dir,BYTE msk) {
    BYTE  bit;

    for(bit = 0x01;(bit)&&(!(bit & msk));bit <<= 1,nID += 2) {
        CheckRadioButton(hDlg,nID,nID + 1,(dir & bit)?  nID + 1 : nID);
    }
}
/*
* ݒ肳ꂽID`FbNEWIE{^𔻒fĂPbOoCgEf[^擾B
*/
BYTE WINAPI GetCheckRadioButton(HWND hDlg,int nID,BYTE msk) {
    BYTE  bit;
    BYTE  rtc;

    for(bit = 0x01,rtc = 0x00;(bit)&&(!(bit & msk));bit <<= 1,nID += 2) {
        if(IsDlgButtonChecked(hDlg,nID + 1) == BST_CHECKED) {
            rtc |= bit;
        }
    }
    return(rtc);
}
/*
* AD^DA ̗LɑΉărbgԂݒ肷
*/
void WINAPI EnableADC(HWND hDlg,BYTE ena) {
    BOOL  bEnable = (ena)?  FALSE : TRUE;
    int   nLoc;

    for(nLoc = 0;nLoc < 10;nLoc++) {
        EnableWindow(GetDlgItem(hDlg,IDC_P1IN0 + nLoc),bEnable);
    }
}
/*
* IO@\I_CAOE{bNX
*/
BOOL WINAPI IOSelDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam) {
    static BYTE  enad;
    PAINTSTRUCT  ps;
    HDC          hDC;

    switch(uMsg) {
        case WM_INITDIALOG:
            SetupChekRadioButton(hDlg,IDC_P0IN0,port.dirp0,0x04);
            SetupChekRadioButton(hDlg,IDC_P12IN0,port.dirp12,0x02);
            SetupChekRadioButton(hDlg,IDC_P3IN0,port.dirp3,0x10);
            SetupChekRadioButton(hDlg,IDC_P6IN0,port.dirp6,0x04);
            SetupChekRadioButton(hDlg,IDC_P1IN0,port.dirp1,0x00);
            enad = port.enad;
            EnableADC(hDlg,enad);
            return(TRUE);
        // used to paint the bitmap
        case WM_PAINT:
            // load bitmap and display it
            hDC = BeginPaint(hDlg,&ps);
            EndPaint(hDlg,&ps);
            break;
        case WM_COMMAND:
            switch(LOWORD(wParam)) {
                case IDOK:
                    port.dirp0  = GetCheckRadioButton(hDlg,IDC_P0IN0,0x04);
                    port.dirp12 = GetCheckRadioButton(hDlg,IDC_P12IN0,0x02);
                    port.dirp3  = GetCheckRadioButton(hDlg,IDC_P3IN0,0x10);
                    port.dirp6  = GetCheckRadioButton(hDlg,IDC_P6IN0,0x04);
                    port.dirp1  = GetCheckRadioButton(hDlg,IDC_P1IN0,0x00);
                    port.enad   = enad;
                    EndDialog(hDlg,TRUE);
                    return(TRUE);
                case IDCANCEL:
                    EndDialog(hDlg,FALSE);
                    return(TRUE);
                case IDC_IOSEL:
                    enad ^= 1;
                    EnableADC(hDlg,enad);
                    break;
                case IDC_AAIN:
                    SetupChekRadioButton(hDlg,IDC_P0IN0,port.dirp0 = 0,0x04);
                    SetupChekRadioButton(hDlg,IDC_P12IN0,port.dirp12 = 0,0x02);
                    break;
                case IDC_BAIN:
                    SetupChekRadioButton(hDlg,IDC_P3IN0,port.dirp3 = 0,0x10);
                    SetupChekRadioButton(hDlg,IDC_P6IN0,port.dirp6 = 0,0x04);
                    break;
                case IDC_DAIN:
                    SetupChekRadioButton(hDlg,IDC_P1IN0,port.dirp1 = 0,0x00);
                    break;
                case IDC_AAOUT:
                    SetupChekRadioButton(hDlg,IDC_P0IN0,port.dirp0 = 0x03,0x04);
                    SetupChekRadioButton(hDlg,IDC_P12IN0,port.dirp12 = 0x01,0x02);
                    break;
                case IDC_BAOUT:
                    SetupChekRadioButton(hDlg,IDC_P3IN0,port.dirp3 = 0x0F,0x10);
                    SetupChekRadioButton(hDlg,IDC_P6IN0,port.dirp6 = 0x03,0x04);
                    break;
                case IDC_DAOUT:
                    SetupChekRadioButton(hDlg,IDC_P1IN0,port.dirp1 = 0xFF,0x00);
                    break;
            }
            break;
        case WM_CLOSE:
            SendMessage(hDlg,WM_COMMAND,IDCANCEL,0);
            break;
    }
    return(FALSE);
}
/*
* EBhEfXNgbv̒ɕ\
*/
VOID WINAPI DisplayCenterWindow(HWND hDlg) {
    HDC     hdc;
    SIZEL   sizeDesktop;
    RECT    rectWin;

    /* fXNgbvƃEBhẼTCY擾 */
    hdc = GetDC(hDlg);
    sizeDesktop.cx = GetDeviceCaps(hdc,HORZRES);
    sizeDesktop.cy = GetDeviceCaps(hdc,VERTRES);
    ReleaseDC(hDlg,hdc);
    GetWindowRect(hDlg,&rectWin);
    /* ʂ̒ɕ\ */
    SetWindowPos(hDlg,HWND_TOPMOST,
            (sizeDesktop.cx / 2) - ((rectWin.right - rectWin.left) / 2),
            (sizeDesktop.cy / 2) - ((rectWin.bottom - rectWin.top) / 2),
            0,0,SWP_NOSIZE);
}
/*
* IO@\̏Ԃ\B
* o̓|[ĝƂ`FbNLƂB
*/
VOID WINAPI SetIOStatus(HWND hDlg,int nID,BYTE port,BYTE msk) {
    BYTE  bit;

    for(bit = 0x01;(bit)&&(!(bit & msk));bit <<= 1,nID++) {
        EnableWindow(GetDlgItem(hDlg,nID),(port & bit)?  TRUE : FALSE);
    }
}
/*
* IO@\̏Ԃ\B
* AD/DA ֘A̕\sB
*/
VOID WINAPI SetEnableIOAD(HWND hDlg,BYTE port,BYTE ena) {
    BOOL  bEnable = (ena)?  FALSE : TRUE;
    int   nLoc;

    for(nLoc = 0;nLoc < 5;nLoc++) {
        EnableWindow(GetDlgItem(hDlg,IDC_P1CHK0 + nLoc),
                     ((ena)||(!(port & (1 << nLoc))))?  FALSE : TRUE);
    }
    bEnable ^= TRUE;
    EnableWindow(GetDlgItem(hDlg,IDE_ADCH0),bEnable);
    EnableWindow(GetDlgItem(hDlg,IDE_ADCH1),bEnable);
    EnableWindow(GetDlgItem(hDlg,IDD_BUTTONAN),bEnable);
    EnableWindow(GetDlgItem(hDlg,IDE_DACH0),bEnable);
    EnableWindow(GetDlgItem(hDlg,IDE_DACH1),bEnable);
    EnableWindow(GetDlgItem(hDlg,IDE_DACH2),bEnable);
    EnableWindow(GetDlgItem(hDlg,IDE_DACH3),bEnable);
    EnableWindow(GetDlgItem(hDlg,IDD_BUTTONDN),bEnable);
}
/*
* USB-IO_CAOE{bNX̕\sB
*/
VOID InitDisp(HWND hDlg) {
    port.dirp0  = 0;
    port.dirp12 = 0;
    port.dirp3  = 0;
    port.dirp6  = 0;
    port.dirp1  = 0;
    port.enad = 0;
    SetIOStatus(hDlg,IDC_P0CHK0,port.dirp0,0x04);
    SetIOStatus(hDlg,IDC_P12CHK0,port.dirp12,0x02);
    SetIOStatus(hDlg,IDC_P3CHK0,port.dirp3,0x10);
    SetIOStatus(hDlg,IDC_P6CHK0,port.dirp6,0x04);
    SetIOStatus(hDlg,IDC_P1CHK0,port.dirp1,0x00);
    SetDlgItemInt(hDlg,IDE_DACH0,0,FALSE);
    SetDlgItemInt(hDlg,IDE_DACH1,0,FALSE);
    SetDlgItemInt(hDlg,IDE_DACH2,0,FALSE);
    SetDlgItemInt(hDlg,IDE_DACH3,0,FALSE);
    SetEnableIOAD(hDlg,port.dirp1,port.enad);
    InvalidateRect(hDlg,NULL,TRUE);
}
/*
* USB-IO_CAOE{bNXWM_INITDIALOG̏
*/
LRESULT WINAPI DoInitDialog(HWND hDlg,WPARAM wParam,LPARAM lParam) {
    INITCOMMONCONTROLSEX InitCtrls;
    HMENU  hMenu;
    int    nLoc;
    HICON  hIcon;

    InitCtrls.dwSize = sizeof(InitCtrls);
    InitCtrls.dwICC = ICC_WIN95_CLASSES;
    InitCommonControlsEx(&InitCtrls);
    hMenu = GetSystemMenu(hDlg,FALSE);
    DeleteMenu(hMenu,SC_SIZE,MF_BYCOMMAND);
    DeleteMenu(hMenu,SC_MAXIMIZE,MF_BYCOMMAND);
    DeleteMenu(hMenu,SC_MINIMIZE,MF_BYCOMMAND);
    InsertMenu(hMenu,0,MF_BYPOSITION | MF_SEPARATOR,0,NULL);
    mii.hSubMenu = NULL;
    mii.fMask    = MIIM_ID | MIIM_TYPE | MIIM_STATE;
    for(nLoc = 2;nLoc >= 0;nLoc--) {
        if(nLoc == 1) {
            mii.fState = (MFS_DISABLED | MFS_GRAYED);
        } else {
            mii.fState = MFS_ENABLED;
        }
        mii.wID        = menu[nLoc].nID;
        mii.dwTypeData = menu[nLoc].lpszMsg;
        InsertMenuItem(hMenu,0,TRUE,&mii);
    }
    DrawMenuBar(hDlg);
    hIcon = LoadIcon(GETHINST(hDlg),MAKEINTRESOURCE(IDI_MAIN));
    SendMessage(hDlg,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)hIcon);
    InitDisp(hDlg);
    DisplayCenterWindow(hDlg);
    initComm(hDlg);
    return(1);
}
/*
* USB-IO_CAOE{bNXWM_CLOSȄ
*/
LRESULT WINAPI DoClose(HWND hDlg,WPARAM wParam,LPARAM lParam) {
    if(hCom != INVALID_HANDLE_VALUE) {
        CloseHandle(hCom);
    }
    EndDialog(hDlg,0);
    return(TRUE);
}

/*
* VXeEj[̕\sB
* AqEBhE䌠Ă邽߁AӖȂB
* ON=MFS_ENABLED,4:Port,2:Script,3:About
*/
void WINAPI CtrlMenuItem(HWND hDlg,BYTE bits) {
    HMENU  hMenu;
    int    nLoc;

    hMenu     = GetSystemMenu(hDlg,FALSE);
    mii.fMask = MIIM_ID | MIIM_TYPE | MIIM_STATE;
    mii.hSubMenu = NULL;
    for(nLoc = 0;nLoc < 3;nLoc++) {
        if(bits & (1 << (2 - nLoc))) {
            mii.fState = MFS_ENABLED;
        } else {
            mii.fState = (MFS_DISABLED | MFS_GRAYED);
        }
        mii.wID        = menu[nLoc].nID;
        mii.dwTypeData = menu[nLoc].lpszMsg;
        SetMenuItemInfo(hMenu,mii.wID,FALSE,&mii);
    }
    DrawMenuBar(hDlg);
    InvalidateRect(hDlg,NULL,TRUE);
}
/*
* w肳ꂽIDoCgEf[^擾B
*/
BYTE WINAPI GetIOData(HWND hDlg,int nID,int nEnd) {
    int   nLoc;
    BYTE  rtc;

    for(rtc = 0,nLoc = 0;nLoc < nEnd;nLoc++) {
        if(IsDlgButtonChecked(hDlg,nID + nLoc) == BST_CHECKED) {
            rtc |= 1 << nLoc;
        }
    }
    return(rtc);
}
/*
* w肳ꂽIDAݒ肳ꂽoCgEf[^WJ`FbNԂ\XVB
*/
VOID WINAPI SetIOData(HWND hDlg,int nID,BYTE data,int nEnd) {
    int  nLoc;

    for(nLoc = 0;nLoc < nEnd;nLoc++) {
        CheckDlgButton(hDlg,nID + nLoc,
                       (data & (1 << nLoc))?  BST_CHECKED : BST_UNCHECKED);
    }
}
/*
* w肳ꂽIDAݒ肳ꂽ[hEf[^\XVB
*/
VOID WINAPI SetADData(HWND hDlg,int nID,WORD ch0,WORD ch1) {
    SetDlgItemInt(hDlg,nID,ch0,FALSE);
    SetDlgItemInt(hDlg,nID + 1,ch1,FALSE);
}
/*
* USB-IO_CAOE{bNXWM_SYSCOMMAND̏
*/
LRESULT WINAPI DoSysCommand(HWND hDlg,WPARAM wParam,LPARAM lParam) {
    BYTE  cmd[32];
    BYTE  buf[16];
    int   nLen;

    switch(wParam) {
        case IDM_PORT:
            CtrlMenuItem(hDlg,1);
            DialogBoxParam(GETHINST(hDlg),
                           MAKEINTRESOURCE(IDD_IOSEL),
                           hDlg,
                           (DLGPROC)IOSelDlgProc,0L);
            SetIOStatus(hDlg,IDC_P0CHK0,port.dirp0,0x04);
            SetIOStatus(hDlg,IDC_P12CHK0,port.dirp12,0x02);
            SetIOStatus(hDlg,IDC_P3CHK0,port.dirp3,0x10);
            SetIOStatus(hDlg,IDC_P6CHK0,port.dirp6,0x04);
            SetIOStatus(hDlg,IDC_P1CHK0,port.dirp1,0x00);
            SetEnableIOAD(hDlg,port.dirp1,port.enad);
            CtrlMenuItem(hDlg,5);
            cmd[0] = CMD_DDRP0;
            cmd[1] = port.dirp0 ^ 0x03;
            cmd[2] = CMD_DDRP12;
            cmd[3] = port.dirp12 ^ 0x01;
            cmd[4] = CMD_DDRP3;
            cmd[5] = port.dirp3 ^ 0x0F;
            cmd[6] = CMD_DDRP6;
            cmd[7] = port.dirp6 ^ 0x03;
            cmd[8] = CMD_DDRP1;
            cmd[9] = port.dirp1 ^ 0xFF;
            nLen   = 10;
            if(port.enad) {
                cmd[9]  = (cmd[9] & 0xF2) | 0x02;
                cmd[10] = CMD_SETAD;
                cmd[11] = CMD_SETDA;
                cmd[12] = 0;
                cmd[13] = 0;
                cmd[14] = 0;
                cmd[15] = 0;
                cmd[16] = 0;
                cmd[17] = 0;
                cmd[18] = 0;
                cmd[19] = 0;
                nLen    = 20;
            }
            cmd[nLen++] = CMD_INP0;
            cmd[nLen++] = CMD_INP12;
            cmd[nLen++] = CMD_INP3;
            cmd[nLen++] = CMD_INP6;
            cmd[nLen++] = CMD_INP1;
            if(port.enad) {
                cmd[nLen++] = CMD_GETAD;
            }
            SendCode(cmd,nLen);
            RecvCode(buf,(nLen > 15)?  9 : 5);
            if(port.enad) {
                buf[4] &= 0xE0;
                SetADData(hDlg,IDE_ADCH0,
                          (WORD)(((WORD)buf[5] << 8) | buf[6]),
                          (WORD)(((WORD)buf[7] << 8) | buf[8]));
            }
            SetIOData(hDlg,IDC_P0CHK0,buf[0],2);
            SetIOData(hDlg,IDC_P12CHK0,buf[1],1);
            SetIOData(hDlg,IDC_P3CHK0,buf[2],4);
            SetIOData(hDlg,IDC_P6CHK0,buf[3],2);
            SetIOData(hDlg,IDC_P1CHK0,buf[4],8);
            break;
        case IDM_SCRIPT:
            CtrlMenuItem(hDlg,1);
            CtrlMenuItem(hDlg,5);
            break;
        case IDM_VERSION:
            CtrlMenuItem(hDlg,4);
            DialogBoxParam(GETHINST(hDlg),
                           MAKEINTRESOURCE(IDD_ABOUT),
                           hDlg,
                           (DLGPROC)AboutDlgProc,0L);
            CtrlMenuItem(hDlg,5);
            break;
        case SC_CLOSE:
            SendMessage(hDlg,WM_CLOSE,0,0);
            break;
    }
    return(0);
}
/*
* USB-IO_CAOE{bNXWM_COMMAND̏
*/
LRESULT WINAPI DoCommand(HWND hDlg,WPARAM wParam,LPARAM lParam) {
    UINT  val;
    BYTE  cmd[16];
    BYTE  buf[8];
    int   len;

    switch(LOWORD(wParam)) {
        case IDD_BUTTONA:
            cmd[0] = CMD_OUTP0;
            cmd[1] = GetIOData(hDlg,IDC_P0CHK0,2);
            cmd[2] = CMD_INP0;
            SendCode(cmd,3);
            RecvCode(buf,1);
            SetIOData(hDlg,IDC_P0CHK0,buf[0],1);
            cmd[0] = CMD_OUTP12;
            cmd[1] = GetIOData(hDlg,IDC_P12CHK0,1);
            cmd[2] = CMD_INP12;
            SendCode(cmd,3);
            RecvCode(buf,1);
            SetIOData(hDlg,IDC_P12CHK0,buf[0],1);
            break;
        case IDD_BUTTONB:
            cmd[0] = CMD_OUTP3;
            cmd[1] = GetIOData(hDlg,IDC_P3CHK0,4);
            cmd[2] = CMD_INP3;
            SendCode(cmd,3);
            RecvCode(buf,1);
            SetIOData(hDlg,IDC_P3CHK0,buf[0],4);
            cmd[0] = CMD_OUTP6;
            cmd[1] = GetIOData(hDlg,IDC_P6CHK0,2);
            cmd[2] = CMD_INP6;
            SendCode(cmd,3);
            RecvCode(buf,1);
            SetIOData(hDlg,IDC_P6CHK0,buf[0],2);
            break;
        case IDD_BUTTOND:
            cmd[0] = CMD_OUTP1;
            cmd[1] = GetIOData(hDlg,IDC_P1CHK0,8);
            cmd[2] = CMD_INP1;
            len    = 3;
            if(port.enad) {
                cmd[1] = (cmd[1] & 0xF9) | 0x09;
                cmd[3] = CMD_SETAD;
                len    = 4;
            }
            SendCode(cmd,len);
            RecvCode(buf,1);
            if(port.enad) {
                buf[0] &= 0xE0;
            }
            SetIOData(hDlg,IDC_P1CHK0,buf[0],8);
            break;
        case IDD_BUTTONAN:
            cmd[0] = CMD_GETAD;
            SendCode(cmd,1);
            RecvCode(buf,4);
            SetADData(hDlg,IDE_ADCH0,
                      (WORD)(((WORD)buf[0] << 8) | buf[1]),
                      (WORD)(((WORD)buf[2] << 8) | buf[3]));
            break;
        case IDE_DACH0:
        case IDE_DACH1:
        case IDE_DACH2:
        case IDE_DACH3:
            if(GetDlgItemInt(hDlg,LOWORD(wParam),NULL,FALSE) >= 1024) {
                SetDlgItemInt(hDlg,LOWORD(wParam),1023,FALSE);
            }
            break;
        case IDD_BUTTONDN:
            cmd[0] = CMD_SETDA;
            for(len = 0;len < 4;len++) {
                val = GetDlgItemInt(hDlg,len + IDE_DACH0,NULL,FALSE);
                cmd[(len * 2) + 1] = (BYTE)(val >> 8);
                cmd[(len * 2) + 2] = (BYTE)(val);
                SetDlgItemInt(hDlg,len + IDE_DACH0,val,FALSE);
            }
            SendCode(cmd,9);
            break;
        case IDD_BUTTONALL:
            PostMessage(hDlg,WM_COMMAND,IDD_BUTTONA,0);
            PostMessage(hDlg,WM_COMMAND,IDD_BUTTONB,0);
            PostMessage(hDlg,WM_COMMAND,IDD_BUTTOND,0);
            if(port.enad) {
                PostMessage(hDlg,WM_COMMAND,IDD_BUTTONAN,0);
                PostMessage(hDlg,WM_COMMAND,IDD_BUTTONDN,0);
            }
            break;
    }
    return(0);
}
/*
* USB-IO_CAOE{bNXWM_DEVICECHANGE
*/
LRESULT WINAPI DoDeviceChange(HWND hDlg,WPARAM wParam,LPARAM lParam) {
    if(!bLoad) {
        Sleep(100);
        if(GetComPortNum() > 0) {
            Sleep(800);
            InitDisp(hDlg);
            initComm(hDlg);
        }
    } else {
        if(GetComPortNum() <= 0) {
            CloseHandle(hCom);
            bLoad = FALSE;
            hCom  = INVALID_HANDLE_VALUE;
            memset(&port,0,sizeof(port));
            MessageBox(hDlg,"78K USBϲ݂O܂B","USBIO-Error",MB_OK);
        }
    }
    return(0);
}
/*
* USB-IO_CAOE{bNX
*/
LRESULT CALLBACK DialogProc(HWND hDlg,UINT uMsg,UINT wParam,LONG lParam) {
    switch(uMsg){
        MSGDISPATCH(WM_DEVICECHANGE,DoDeviceChange);
        MSGDISPATCH(WM_COMMAND,   DoCommand);
        MSGDISPATCH(WM_SYSCOMMAND,DoSysCommand);
        MSGDISPATCH(WM_CLOSE,     DoClose);
        MSGDISPATCH(WM_INITDIALOG,DoInitDialog);
    }
    return(0);
}
/*
* C
*/
int APIENTRY WinMain(
HINSTANCE hInstance,
HINSTANCE hPrevInstance,
LPSTR lpszCmdLine,
int nCmdShow) {
    int  rtc;

    rtc = DialogBox(hInstance,(LPCSTR)IDD_USBIO,NULL,DialogProc);
    return(rtc);
}
